/* feynhiggsfastsub.f -- translated by f2c (version 19991025).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    doublereal mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, el, gf;
} smpara_;

#define smpara_1 smpara_

struct {
    doublereal cf, eps, pi;
    doublecomplex i__;
} para_;

#define para_1 para_

struct {
    doublereal mst1, mst2, stt, ctt, delmst, msb1, msb2, stb, ctb, msusy, 
	    msusytl, msusytr, msusybl, msusybr, mtlr, mblr, au, ad, mmm, mgl, 
	    mue, beta, alpha, tb, ma;
} susypara_;

#define susypara_1 susypara_

struct {
    doublereal mhh, mlh;
} higgsmass_;

#define higgsmass_1 higgsmass_

struct {
    integer selec2, selec3;
} selec_;

#define selec_1 selec_

struct {
    doublereal mlhlle1, mlhlle2, mlhllediag1, mlhllediag2, mhhllediag1, 
	    mhhllediag2, alphadiag1, alphadiag2, mhptree, mhp;
} lle_;

#define lle_1 lle_

/* Table of constant values */

static integer c__9 = 9;
static integer c__1 = 1;
static integer c__5 = 5;

/* ------------------------------------------------------------------------ */
/* ------------------------------------------------------------------------ */
/* Subroutine */ int feynhiggsfastsub_()
{
    /* System generated locals */
    doublereal d__1, d__2, d__3, d__4, d__5, d__6, d__7, d__8;

    /* Builtin functions */
    double sqrt(), log();

    double atan(), cos(), acos();

    /* Local variables */
    static doublereal gmue, mtold;
    extern /* Subroutine */ int mhiggslle_();
    static doublereal mb2, mw2, mz2;
    extern /* Subroutine */ int def2_(), def3_();
    static doublereal mhh2, mlh2;

    /* Fortran I/O blocks */


/*      if((dabs(mue)/1000d0 + tb/25d0).gt.2d0)then */
/*         write(*,*) 'WARNING - WARNING - WARNING - WARNING' */
/*         write(*,*) 'Mue-tan(beta) combination enforces m_b = 0' */
/*         write(*,*) 'WARNING - WARNING - WARNING - WARNING' */
/*         mb = 0.001 */
/*      endif */
/* Computing 2nd power */
    d__1 = smpara_1.mz;
    mz2 = d__1 * d__1;
/* Computing 2nd power */
    d__1 = smpara_1.mw;
    mw2 = d__1 * d__1;
/* Computing 2nd power */
    d__1 = smpara_1.mw / smpara_1.mz;
    smpara_1.sw2 = 1. - d__1 * d__1;
/* Computing 2nd power */
    d__1 = smpara_1.mw;
/* Computing 2nd power */
    d__2 = smpara_1.mw;
/* Computing 2nd power */
    d__3 = smpara_1.mz;
    smpara_1.el = sqrt(smpara_1.gf * 8. * (d__1 * d__1) * (1 - d__2 * d__2 / (
	    d__3 * d__3)) / sqrt(2.));
    smpara_1.gs = sqrt(para_1.pi * 4 * smpara_1.as);
    gmue = smpara_1.gf;
/* Computing 2nd power */
    d__1 = smpara_1.mb;
    mb2 = d__1 * d__1;
/*      write(*,*) 'mtrun:', alphasmz, mt, mmz, pi */
/* Computing 2nd power */
    d__1 = smpara_1.mt;
/* Computing 2nd power */
    d__2 = smpara_1.mz;
    smpara_1.as = smpara_1.alphasmz / (7.6666666666666661 / (para_1.pi * 4.) *
	     smpara_1.alphasmz * log(d__1 * d__1 / (d__2 * d__2)) + 1.);
    smpara_1.mtrun = smpara_1.mt / (4. / (para_1.pi * 3.) * smpara_1.as + 1.);
    if (selec_1.selec2 >= 3) {
	smpara_1.mt = smpara_1.mtrun;

    }
    if (selec_1.selec3 == 2) {
	def3_(&susypara_1.tb, &susypara_1.mst2, &susypara_1.delmst, &
		susypara_1.stt, &smpara_1.mw, &smpara_1.mz, &smpara_1.mt, &
		susypara_1.msusytl, &susypara_1.msusytr, &susypara_1.msusybl, 
		&susypara_1.msusybr, &susypara_1.mtlr);
    }
    susypara_1.au = susypara_1.mtlr + susypara_1.mue / susypara_1.tb;
    susypara_1.ad = susypara_1.au;
/* --> note: At = Ab is an arbitrary choice */
    susypara_1.mblr = susypara_1.ad - susypara_1.mue * susypara_1.tb;
    susypara_1.beta = atan(susypara_1.tb);
/* Computing 2nd power */
    d__1 = susypara_1.ma;
/* Computing 2nd power */
    d__2 = smpara_1.mz;
/* Computing 2nd power */
    d__4 = susypara_1.ma;
/* Computing 2nd power */
    d__5 = smpara_1.mz;
/* Computing 2nd power */
    d__3 = d__4 * d__4 + d__5 * d__5;
/* Computing 2nd power */
    d__6 = smpara_1.mz;
/* Computing 2nd power */
    d__7 = susypara_1.ma;
/* Computing 2nd power */
    d__8 = cos(susypara_1.beta * 2.);
    mlh2 = (d__1 * d__1 + d__2 * d__2 - sqrt(d__3 * d__3 - d__6 * d__6 * 4. * 
	    (d__7 * d__7) * (d__8 * d__8))) * .5;
    higgsmass_1.mlh = sqrt(mlh2);
/* Computing 2nd power */
    d__1 = susypara_1.ma;
/* Computing 2nd power */
    d__2 = smpara_1.mz;
/* Computing 2nd power */
    d__4 = susypara_1.ma;
/* Computing 2nd power */
    d__5 = smpara_1.mz;
/* Computing 2nd power */
    d__3 = d__4 * d__4 + d__5 * d__5;
/* Computing 2nd power */
    d__6 = smpara_1.mz;
/* Computing 2nd power */
    d__7 = susypara_1.ma;
/* Computing 2nd power */
    d__8 = cos(susypara_1.beta * 2.);
    mhh2 = (d__1 * d__1 + d__2 * d__2 + sqrt(d__3 * d__3 - d__6 * d__6 * 4. * 
	    (d__7 * d__7) * (d__8 * d__8))) * .5;
    higgsmass_1.mhh = sqrt(mhh2);
/* Computing 2nd power */
    d__1 = susypara_1.ma;
/* Computing 2nd power */
    d__2 = smpara_1.mz;
    susypara_1.alpha = acos(-cos(susypara_1.beta * 2.) * (d__1 * d__1 - d__2 *
	     d__2) / (mhh2 - mlh2)) / 2.;
    if (susypara_1.alpha > 0.) {
	susypara_1.alpha = -susypara_1.alpha;
    }
/* Computing 2nd power */
    d__1 = susypara_1.ma;
/* Computing 2nd power */
    d__2 = smpara_1.mw;
    lle_1.mhptree = sqrt(d__1 * d__1 + d__2 * d__2);
    def2_();
/* $$$      write(*,*) '-------------------------------------------' */
/* $$$      write(*,*) 'Sfermions:' */
/* $$$      write(*,*) 'MSt1, MSt2, stt' */
/* $$$      write(*,*) mst1, mst2, stt */
/* $$$      write(*,*) 'MSb1, MSb2, stb' */
/* $$$      write(*,*) msb1, msb2, stb */
/* $$$      write(*,*) '-------------------------------------------' */
/* ------------------------------------------------------------- */
    mtold = smpara_1.mt;
/*      write(*,*) 'vor lle' */
/* $$$      write(*,*) 'LLE parameters:' */
/* $$$      write(*,*) real(msusytl), real(msusytr), real(mtlr), real(mtold), */
/* $$$     $           real(mt), real(mb), real(ma), real(tb), real(gf), */
/* $$$     $           real(as), real(cf), real(el), real(mz), real(mw) */
    mhiggslle_(&susypara_1.msusytl, &susypara_1.msusytr, &susypara_1.mtlr, &
	    susypara_1.mblr, &mtold, &smpara_1.mt, &smpara_1.mb, &
	    susypara_1.mst1, &susypara_1.mst2, &susypara_1.stt, &
	    susypara_1.ma, &susypara_1.tb, &susypara_1.alpha, &smpara_1.gf, &
	    smpara_1.as, &para_1.cf, &smpara_1.el, &smpara_1.mz, &smpara_1.mw,
	     &susypara_1.mue, &lle_1.mlhlle1, &lle_1.mlhlle2, &
	    lle_1.mlhllediag1, &lle_1.mlhllediag2, &lle_1.mhhllediag1, &
	    lle_1.mhhllediag2, &lle_1.alphadiag1, &lle_1.alphadiag2, &
	    lle_1.mhp);
/*      write(*,*) 'nach lle' */
/* ------------------------------------------------------------- */
/* L999: */
} /* feynhiggsfastsub_ */

